# coding: utf-8

##
# Project: ScoPy
# Author: Marco Scarpetta <marcoscarpetta@mailoo.org>
# Copyright: 2012 Marco Scarpetta
# License: GPL-3+
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
# more details.
#
# On Debian GNU/Linux systems, the full text of the GNU General Public License
# can be found in the file /usr/share/common-licenses/GPL-3.
##

from gettext import gettext as _
from gi.repository import Gtk
from base import *

Path=_('Edit')
Name=_('Settings')
	
#modifica le preferenze in base ai valori dati dall'utente
def modifica_preferenze(widget,app,carte_combo,velocita,sfondi_combo,win_pre):
	if app.opzioni['carte'] != tipi_di_carte[carte_combo.get_active()]:
		app.opzioni['carte'] = tipi_di_carte[carte_combo.get_active()]
		a=app.posizioni['terra_c']
		app.calc_posizioni()
		app.posizioni['terra_c']=a
		for carta in app.partita.carte_terra.carte:
			app.carte[carta.uid].set_from_file(percorso_carte+app.opzioni['carte']+'/'+immagini[carta.palo][carta.valore])
		n=0
		while n < len(app.posizioni['terra_c']):
			if app.posizioni['terra_c'][n] != 0:
				app.posizioni['terra_c'][n].set_position(app.posizioni['terra'][n][0], app.posizioni['terra'][n][1])
			n=n+1
		for carta in app.partita.giocatore[0].mano.carte:
			app.carte[carta.uid].set_from_file(percorso_carte+app.opzioni['carte']+'/'+immagini[carta.palo][carta.valore])
		for carta in app.partita.giocatore[1].mano.carte:
			app.carte[carta.uid].set_from_file(percorso_carte+app.opzioni['carte']+'/'+immagini[1][0])
	app.opzioni['speed']=str(velocita.get_value())
	app.time = times[int(float(app.opzioni['speed']))]
	app.opzioni['sfondo']=sfondi[sfondi_combo.get_active()]
	app.back_img.set_from_file(percorso_tap+app.opzioni['sfondo']+'.png')
	app.save()
	app.window.resize(10,10)
	win_pre.destroy()

def main(widget, app):
	win_pre = Gtk.Window()
	win_pre.set_title(_('Edit Settings'))
	win_pre.set_transient_for(app.window)
	win_pre.set_position(Gtk.WindowPosition.CENTER_ON_PARENT)
	win_pre.set_border_width(10)
	win_pre.connect('delete-event', destroy)
	table=Gtk.Table(2,5,False)
	table.set_row_spacings(5)
	table.set_col_spacings(5)
	table.attach(Gtk.Label(_('Chose the type of cards:')),0,1,0,1,Gtk.AttachOptions(0),Gtk.AttachOptions(0))
	table.attach(Gtk.Label(_('Speed:')),0,1,1,2,Gtk.AttachOptions(0),Gtk.AttachOptions(0))
	table.attach(Gtk.Label(_('Background:')),0,1,2,3,Gtk.AttachOptions(0),Gtk.AttachOptions(0))
	carte_combo=Gtk.ComboBoxText()
	for tipo in tipi_di_carte:
		carte_combo.append_text(tipo)
	sfondi_combo=Gtk.ComboBoxText()
	for sfondo in sfondi:
		sfondi_combo.append_text(sfondo)
	velocita=Gtk.HScale.new_with_range(1,3,1)
	table.attach(carte_combo,1,2,0,1,Gtk.AttachOptions(4),Gtk.AttachOptions(4))
	table.attach(velocita,1,2,1,2,Gtk.AttachOptions(4),Gtk.AttachOptions(4))
	table.attach(sfondi_combo,1,2,2,3,Gtk.AttachOptions(4),Gtk.AttachOptions(4))
	button=Gtk.Button()
	button.set_label(_('OK'))
	button.connect('pressed',modifica_preferenze,app,carte_combo,velocita,sfondi_combo,win_pre)
	table.attach(button,1,2,4,5,Gtk.AttachOptions(0),Gtk.AttachOptions(0))
	win_pre.add(table)
	carte_combo.set_active(tipi_di_carte.index(app.opzioni['carte']))
	sfondi_combo.set_active(sfondi.index(app.opzioni['sfondo']))
	velocita.set_value(int(float(app.opzioni['speed'])))
	win_pre.show_all()